SystemOrganization addCategory: #ConfigurationOfSCouchDB!

Object subclass: #ConfigurationOfSCouchDB
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSCouchDB'!

!ConfigurationOfSCouchDB class methodsFor: 'development support' stamp: 'JesusMari 2/4/2013 12:13'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSCouchDB class methodsFor: 'private' stamp: 'JesusMari 2/4/2013 12:13'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSCouchDB class methodsFor: 'private' stamp: 'JesusMari 2/4/2013 12:13'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSCouchDB class methodsFor: 'private' stamp: 'JesusMari 2/4/2013 12:13'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSCouchDB class methodsFor: 'metacello tool support' stamp: 'JesusMari 2/4/2013 12:13'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSCouchDB class methodsFor: 'loading' stamp: 'JesusMari 2/4/2013 12:13'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSCouchDB class methodsFor: 'loading' stamp: 'JesusMari 2/4/2013 12:13'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSCouchDB class methodsFor: 'loading' stamp: 'JesusMari 2/4/2013 12:13'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSCouchDB class methodsFor: 'accessing' stamp: 'JesusMari 2/4/2013 12:13'!
project

	^self new project! !

!ConfigurationOfSCouchDB class methodsFor: 'development support' stamp: 'JesusMari 2/4/2013 12:13'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSCouchDB methodsFor: 'baselines' stamp: 'JesusMari 2/19/2013 18:54'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/SCouchViewServer'.
		spec project: 'SeasideCore' with: [
   			spec
     				className: 'ConfigurationOfSeaside30';
     				versionString: #stable;
     				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'JSON'; 
			package: 'SCouchDB-Core';
			package: 'SCouchDB-ViewServer' with:[spec requires:#('JSON'  'SCouchDB-Core')];
			package: 'SCouchDB-Application-Core' with:[spec requires:'SCouchDB-ViewServer'];
			package: 'SCouchDB-Application-Evently-Core' with:[spec requires:'SCouchDB-Application-Core'];
			package: 'SCouchDB-JQuery-Core'with:[spec requires:'SeasideCore'];
			package: 'SCouchDB-JQuery-Libs'with:[spec requires:'SeasideCore'];
			package: 'Mustache-Core' with:[spec requires:#('JSON'  'SCouchDB-Core')];
			package: 'Mustache-Seaside-Core' with:[spec requires:#('Mustache-Core' 'SeasideCore')];
			package: 'Mustache-Seaside-Libs'with:[spec requires:'SeasideCore'];
			package: 'SCouchDB-Tests' with: [spec requires:'SCouchDB-Core'];
			package: 'SCouchDB-JQuery-Tests' with: [spec requires:'SCouchDB-JQuery-Core'].
			
		spec group: 'base' with:#('JSON' 'JSON-Platform' 'SCouchDB-Core' 'SCouchDB-Platform');
		 	group: 'default' with: #('base' 'SCouchDB-ViewServer' 'SCouchDB-Application-Core'  'SCouchDB-Application-Evently-Core' 'SCouchDB-JQuery-Core' 'SCouchDB-JQuery-Libs' 'Mustache-Core' 'Mustache-Seaside-Core' 'Mustache-Seaside-Libs');
			group: 'viewserver' with: #('base' 'SCouchDB-ViewServer' );
			group: 'appserver' with: #('viewserver' 'SCouchDB-Application-Core'  'SCouchDB-Application-Evently-Core'); 		
			group: 'jquerycouchplugin' with:#('SCouchDB-JQuery-Core' 'SCouchDB-JQuery-Libs');
			group: 'mustache' with:#('JSON' 'Mustache-Core');
			group: 'mustache-seaside' with:#('mustache'  'Mustache-Seaside-Core' 'Mustache-Seaside-Libs');
			group: 'base-tests' with:#('SCouchDB-Test')
		
		 ].
	
spec for: #'squeak' do: [
	spec
			package: 'JSON-Platform' with: 'JSON-Squeak'; "only Squeak"
			package: 'SCouchDB-Platform' with: 'SCouchDB-Core-Squeak' "only Squeak"
]! !

!ConfigurationOfSCouchDB methodsFor: 'symbolic versions' stamp: 'JesusMari 2/4/2013 12:13'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfSCouchDB methodsFor: 'accessing' stamp: 'JesusMari 2/4/2013 12:13'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSCouchDB methodsFor: 'versions' stamp: 'JesusMari 2/19/2013 14:31'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'JesusMari'.
		spec timestamp: '2/19/2013 12:13'.
		spec
			package: 'JSON' with: 'JSON-JesusMari.Stasenko.48'; 
			package: 'SCouchDB-Core' with: 'SCouchDB-Core-JesusMari.4';
			package: 'SCouchDB-ViewServer' with: 'SCouchDB-ViewServer-JesusMari.22';
			package: 'SCouchDB-Application-Core' with: 'SCouchDB-Application-Core-JesusMari.1';
			package: 'SCouchDB-Application-Evently-Core' with: 'SCouchDB-Application-Evently-Core-JesusMari.1';
			package: 'SCouchDB-JQuery-Core' with: 'SCouchDB-JQuery-Core-JesusMari.1';
			package: 'SCouchDB-JQuery-Libs' with: 'SCouchDB-JQuery-Libs-JesusMari.1';
			package: 'Mustache-Core' with:'Mustache-Core-JesusMari.14';
			package: 'Mustache-Seaside-Core' with:'Mustache-Seaside-Core-JesusMari.1';
			package: 'Mustache-Seaside-Libs' with:'Mustache-Seaside-Libs-JesusMari.2';
			"tests packages"
			package: 'SCouchDB-Tests' with: 'SCouchDB-Tests-JesusMari.8';
			package: 'SCouchDB-Application-Tests-Functional' with: 'SCouchDB-Application-Tests-Functional-JesusMari.1';
			package: 'SCouchDB-Application-Evently-Tests-Functional' with: 'SCouchDB-Application-Evently-Tests-Functional-JesusMari.1';
			package: 'SCouchDB-JQuery-Tests' with: 'SCouchDB-JQuery-Tests-JesusMari.1';
			package: 'Mustache-Tests' with:'Mustache-Tests-JesusMari.1';
			package: 'Mustache-Seaside-Tests-Functional' with:'Mustache-Seaside-Tests-Functional-JesusMari.1'
			 ].
spec for: #'pharo' do: [
	spec
			package: 'JSON-Platform'; "only Squeak"
			package: 'SCouchDB-Platform' "only Squeak"
			].
spec for: #'squeak' do: [
	spec
			package: 'JSON-Platform' with: 'JSON-Squeak-jma.1'; "only Squeak"
			package: 'SCouchDB-Platform' with: 'SCouchDB-Core-Squeak-jma.1' "only Squeak"
	]! !
